using System;
using System.Xml.Serialization;
using MediaPortal.GUI.Library;
using MediaPortal.Util;

// need when using a dialog box or the virtual keyboard
using MediaPortal.GUI.Library;
using MediaPortal.Dialogs;

using Microsoft.Office.Core;
using System.Reflection;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace MediaPortal.Plugins.MySlideShows
{

	public class MySlideShows :  GUIWindow, ISetupForm
	{

		#region Construction & cleanup

		public MySlideShows()
		{
			// TODO: Assign a unique window ID here
			GetID = 30000;
		}

		~MySlideShows()
		{
		}

		#endregion Construction & cleanup
		
		#region Serialization

		[Serializable]
			public class Settings
		{
			public Settings()
			{
			}

			[XmlElement("sharenames")]
			public string sharenames
			{ get { return m_strNames; } set { m_strNames = value; } }
			[XmlElement("sharefolders")]
			public string sharefolders
			{ get { return m_strFolders; } set { m_strFolders = value; } }
			[XmlElement("FacadeViewMode")]
			public GUIFacadeControl.ViewMode  FacadeViewMode
			{ get { return m_ViewMode; } set { m_ViewMode = value; } }
			[XmlElement("SlideshowViewType")]
			public int SlideshowViewType
			{ get { return m_ViewType; } set { m_ViewType = value; } }
			[XmlElement("ViewSharenames")]
			public bool ViewShareNames
			{ get { return m_ViewShareNames; } set { m_ViewShareNames = value; } }

			public void Load(GUIButtonControl btnFileShares)
			{
				using(MediaPortal.Profile.Xml xmlreader = new MediaPortal.Profile.Xml("MediaPortal.xml"))
				{
					m_strNames = xmlreader.GetValueAsString("MySlideshows","sharenames","");
					m_strFolders = xmlreader.GetValueAsString("MySlideshows","sharefolders","");
					m_ViewMode = (GUIFacadeControl.ViewMode)xmlreader.GetValueAsInt("MySlideshows","SlideshowViewMode",0);
					m_ViewType = xmlreader.GetValueAsInt("MySlideshows","SlideshowViewType",0);
					if (m_ViewType == (int)ViewTypes.VT_SHARES)
            btnFileShares.Label = GUILocalizeStrings.Get((int)Strings.LABEL_SHARES);
					m_ViewShareNames = xmlreader.GetValueAsBool("ViewSharenames","SlideshowViewType",false);
				}
			}

			public void Save()
			{
				using(MediaPortal.Profile.Xml xmlwriter = new MediaPortal.Profile.Xml("MediaPortal.xml"))
				{
					xmlwriter.SetValue("MySlideshows","SlideshowViewMode",(int)m_ViewMode);
					xmlwriter.SetValue("MySlideshows","SlideshowViewType",m_ViewType);
					xmlwriter.SetValue("MySlideshows","ViewSharenames",m_ViewShareNames);
				}
			}

			// TODO: Declare your member variables for each setting/property
			protected string		m_strNames = "";
			protected string		m_strFolders = "";
			protected GUIFacadeControl.ViewMode m_ViewMode = GUIFacadeControl.ViewMode.List;
			protected int m_ViewType = 0;
			protected bool m_ViewShareNames = false;
		}

		#endregion Serialization

		#region Helper Enums

		// TODO: declare meaningful names for window's controls here
		enum Controls
		{
			BUTTON_VIEWAS			= 2,
			BUTTON_FILES_SHARES = 3,
			TOGGLE_SHARENAMES		= 4,
			CONTROL_FACADE_VIEW		= 6
		};

		// TODO: declare meaningful names for the strings used by the window
		enum Strings
		{
			SHOW_LIST				= 101,
			SHOW_ICONS				= 100,
			SHOW_BIG_ICONS			= 417,
			SHOW_FILM_STRIP			= 733,
			LABEL_MYSLIDESHOWS		= 30001,
			LABEL_ALLFILES			= 30004,
			LABEL_SHARES				= 30005
		}

		enum ViewTypes
		{
			VT_ALLFILES = 0,
			VT_SHARES = 1
		}

		#endregion Helper Enums

		#region Overrides

		public override bool Init()
		{
			// TODO: The specifies the skin files to be used, it needs to be changed
			//		 on a per-plugin basis
			/*Log.Write("========= Starting PPT ===========");
			PowerPoint.Application ppApp = new PowerPoint.Application();
			PowerPoint._Presentation ppPres = ppApp.Presentations.Open("C:\\Program Files\\Team MediaPortal\\MediaPortal\\test.ppt",MsoTriState.msoTrue, MsoTriState.msoFalse,MsoTriState.msoFalse);
			Log.Write(ppPres.Name);
			ppPres.SlideShowSettings.Run();*/
			bool result =  Load(GUIGraphicsContext.Skin + @"\myslideshows.xml");
			return result;
		}

		public override void OnAction(Action action)
		{
			base.OnAction(action);
			if(action.wID == Action.ActionType.ACTION_KEY_PRESSED)
			{
				int key = action.m_key.KeyCode;
				if (key == (int)Keys.Enter)
				{
					switch(GetFocusControlId())
					{
						case (int)Controls.BUTTON_VIEWAS:
							OnChangeViewAs();
							break;
						case (int)Controls.BUTTON_FILES_SHARES:
							OnChangeFilesShares();
							break;
						case (int)Controls.CONTROL_FACADE_VIEW:
							OnFacadeViewClick();
							break;
					}
				}
			}
		}

		public override bool OnMessage(GUIMessage message)
		{
			base.OnMessage(message);
			switch(message.Message )
			{				
				case GUIMessage.MessageType.GUI_MSG_WINDOW_INIT:
					OnInit();					
					return true;
				case GUIMessage.MessageType.GUI_MSG_WINDOW_DEINIT:
					OnDeinit();
					break;
				case GUIMessage.MessageType.GUI_MSG_CLICKED:
				{
					switch(message.SenderControlId)
					{
						case (int)Controls.BUTTON_VIEWAS:
							OnChangeViewAs();
							break;
						case (int)Controls.CONTROL_FACADE_VIEW:
							OnFacadeViewClick();
							break;
						case (int)Controls.BUTTON_FILES_SHARES:
							OnChangeFilesShares();
							break;
						case (int)Controls.TOGGLE_SHARENAMES:
							OnToggleSharenames();
							break;
					}
					break;
				}
			}

			return true;
		}

		#endregion Overrides

		#region Plugin Setup

		public bool CanEnable()
		{
			// TODO: Return true if the plugin can be enabled in the Config->plugins
			return true;
		}

		public bool HasSetup()
		{
			// TODO: Return true if the plugin has additional setup in the Config->plugins
			return true;
		}

		public string PluginName()
		{
			// TODO: Return the name of the plugin as it should appear in Config->plugins
			return "MySlideShows";
		}

		public bool DefaultEnabled()
		{
			// TODO: Return true if the plugin should be enabled by default
			return true;
		}

		public int GetWindowId()
		{
			return GetID;
		}

		public bool GetHome(out string strButtonText, out string strButtonImage, out string strButtonImageFocus, out string strPictureImage)
		{
			strButtonText = GUILocalizeStrings.Get((int)Strings.LABEL_MYSLIDESHOWS);
			strButtonImage = "";
			strButtonImageFocus = "";
			strPictureImage = "hover_my example.png";

			return true;
		}

		public string Author()
		{
			// TODO: Place your name here
			return "MrTurner";
		}

		public string Description()
		{
			// TODO: Place a good description of the plugin
			return "MySlideShows is a plugin that allows you to browse and start Powerpoint Presentations";
		}

		public void ShowPlugin()
		{
			// TODO: Display the Config->Plugins extra setup
			MySlideShowsSetup frmSetup = new MySlideShowsSetup();
			frmSetup.Show();
		}

		#endregion Plugin Setup

		#region Implementation

		void OnInit()
		{
			facadeView = GetControl((int)Controls.CONTROL_FACADE_VIEW) as GUIFacadeControl;
			btnFilesShares = GetControl((int)Controls.BUTTON_FILES_SHARES) as GUIButtonControl;
			btnViewAs = GetControl((int)Controls.BUTTON_VIEWAS) as GUIButtonControl;
			tbtSharenames = GetControl((int)Controls.TOGGLE_SHARENAMES) as GUIToggleButtonControl;

			// load the settings used by this window
			_Settings.Load(btnFilesShares);

			// Register the dsofile.dll for use in MySlideShowInfo
			System.Diagnostics.ProcessStartInfo proc = new System.Diagnostics.ProcessStartInfo();
			proc.FileName = "regsvr32.exe";
			proc.Arguments = "/s dsofile.dll";
			Utils.StartProcess(proc,true);

			facadeView.View = _Settings.FacadeViewMode;
			switch(_Settings.FacadeViewMode)
			{
				case GUIFacadeControl.ViewMode.List:
					btnViewAs.Label = GUILocalizeStrings.Get((int)Strings.SHOW_LIST);
					break;
				case GUIFacadeControl.ViewMode.SmallIcons:
					btnViewAs.Label = GUILocalizeStrings.Get((int)Strings.SHOW_ICONS);
					break;
				case GUIFacadeControl.ViewMode.LargeIcons:
					btnViewAs.Label = GUILocalizeStrings.Get((int)Strings.SHOW_BIG_ICONS);
					break;
				case GUIFacadeControl.ViewMode.Filmstrip:
					btnViewAs.Label = GUILocalizeStrings.Get((int)Strings.SHOW_FILM_STRIP);
					break;
			}

			LoadFiles();				
		}

		void SearchFiles(string dir, string sharename, bool isShare, bool isRoot)
		{
			if((_Settings.SlideshowViewType == (int)ViewTypes.VT_SHARES) && !isRoot)
			{
				GUIListItem lItem = new GUIListItem();
				lItem.Label = "..";
				if(!isShare)
					lItem.Path = dir.Substring(0,dir.LastIndexOf("\\"));
				if(_Settings.ViewShareNames == true)
					lItem.Label2 = sharename;
				facadeView.Add(lItem);	
			}

			string[] files = System.IO.Directory.GetFiles(dir,"*");
			foreach(string file in files)
			{
				System.IO.FileInfo info = new System.IO.FileInfo(file);
				if (!((info.Extension == ".ppt") || (info.Extension == ".pps")))
					continue;
				GUIListItem lItem = new GUIListItem();
				lItem.Label = info.Name;
				lItem.Path = info.FullName;
				if(_Settings.ViewShareNames == true)
					lItem.Label2 = sharename;
				facadeView.Add(lItem);	
			}	

			if(_Settings.SlideshowViewType == (int)ViewTypes.VT_ALLFILES)
			{
				string[] dirs = System.IO.Directory.GetDirectories(dir,"*");
				foreach(string mDir in dirs)
				{
					SearchFiles(mDir,sharename + mDir.Substring(mDir.LastIndexOf("\\")),false,false);
				}
			}
		}

		void LoadFiles()
		{
			facadeView.Clear();

			char[] sep = new char[]{'|'};

			if(_Settings.sharefolders.Length == 0 )
				return;
		
			string[] sNames = _Settings.sharenames.Split(sep);
			string[] sFolders = _Settings.sharefolders.Split(sep);

			if (_Settings.SlideshowViewType == (int)ViewTypes.VT_ALLFILES)
			{
				for (int i = 0; i<sFolders.Length; i++)
				{
					SearchFiles(sFolders[i], sNames[i], true,true);
				}
			}
			else
			{
				btnFilesShares.Label = GUILocalizeStrings.Get((int)Strings.LABEL_SHARES);
				facadeView.Clear();
				for (int i = 0; i<sFolders.Length; i++)
				{
					GUIListItem lItem = new GUIListItem();
					lItem.Label = sNames[i];
					lItem.Path = sFolders[i];
					if(_Settings.ViewShareNames == true)
						lItem.Label2 = sNames[i];
					facadeView.Add(lItem);	
				}
			}
		}

		void OnDeinit()
		{
			// TODO: perform any additional cleanup
			_Settings.Save();
		}

		void OnSelectItem()
		{			
		}

		void OnChangeViewAs()
		{
			switch(facadeView.View)
			{
				case GUIFacadeControl.ViewMode.List:
					facadeView.View = GUIFacadeControl.ViewMode.SmallIcons;
					btnViewAs.Label = GUILocalizeStrings.Get((int)Strings.SHOW_ICONS);
					break;
				case GUIFacadeControl.ViewMode.SmallIcons:
					facadeView.View = GUIFacadeControl.ViewMode.LargeIcons;
					btnViewAs.Label = GUILocalizeStrings.Get((int)Strings.SHOW_BIG_ICONS);
					break;
				case GUIFacadeControl.ViewMode.LargeIcons:
					facadeView.View = GUIFacadeControl.ViewMode.Filmstrip;
					btnViewAs.Label = GUILocalizeStrings.Get((int)Strings.SHOW_FILM_STRIP);
					break;
				case GUIFacadeControl.ViewMode.Filmstrip:
					facadeView.View = GUIFacadeControl.ViewMode.List;
					btnViewAs.Label = GUILocalizeStrings.Get((int)Strings.SHOW_LIST);
					break;
			}

			_Settings.FacadeViewMode = facadeView.View;
			LoadFiles();
			
		}

		void OnFacadeViewClick()
		{
			currentFile = facadeView.SelectedListItem.Path;
			string currentShare =  facadeView.SelectedListItem.Label2;
		
			if(System.IO.File.Exists(currentFile))
				GUIWindowManager.ActivateWindow(GetID + 1);
			else
			{
				facadeView.Clear();
				Log.Write("Search " + currentFile);
				char[] sep = new char[]{'|'};
		
				string[] sFolders = _Settings.sharefolders.Split(sep);
				if(currentFile == "")
				{
					string[] sNames = _Settings.sharenames.Split(sep);
					for (int i = 0; i<sFolders.Length; i++)
					{
						GUIListItem lItem = new GUIListItem();
						lItem.Label = sNames[i];
						lItem.Path = sFolders[i];
						if(_Settings.ViewShareNames == true)
							lItem.Label2 = sNames[i];
						facadeView.Add(lItem);	
					}
				}
				else
				{
					bool isShare = false;
					foreach(string folder in sFolders)
					{
						if(currentFile == folder)
							isShare = true;
					}
					SearchFiles(currentFile, currentShare, isShare, false);
				}
			}
		}

		void OnToggleSharenames()
		{
			if(tbtSharenames.Selected)
					_Settings.ViewShareNames = true;
			else
					_Settings.ViewShareNames = false;

			LoadFiles();
		}

		void OnChangeFilesShares()
		{
			if (btnFilesShares.Label == GUILocalizeStrings.Get((int)Strings.LABEL_ALLFILES))
			{
				_Settings.SlideshowViewType = (int)ViewTypes.VT_SHARES;
				btnFilesShares.Label = GUILocalizeStrings.Get((int)Strings.LABEL_SHARES);
				facadeView.Clear();
			}
			else
			{
				_Settings.SlideshowViewType = (int)ViewTypes.VT_ALLFILES;		
				btnFilesShares.Label = GUILocalizeStrings.Get((int)Strings.LABEL_ALLFILES);
			}
			LoadFiles();
		}

		#endregion Implementation

		#region Member Variables
		Settings					_Settings = new Settings();
		public static  string		currentFile = "";
		protected string[] mFileToSharenames;
	
		[SkinControlAttribute(2)] protected GUIButtonControl btnViewAs = null;
		[SkinControlAttribute(4)] protected GUIToggleButtonControl tbtSharenames = null;
		[SkinControlAttribute(6)] protected GUIFacadeControl facadeView = null;
		[SkinControlAttribute(3)] protected GUIButtonControl btnFilesShares = null;
		
		#endregion Member Variables
	}

	
}
